# Java Fundamentals

### **Objective:**
* To complete the method stubs in each of the provided classes
	* `MathUtilities`
	* `PredicateUtilities`
	* `StringUtilities`

### **Purpose:**
* To establish familiarity with
    * [primitive data-types](http://cs.fit.edu/~ryan/java/language/java-data.html)
    * [method signatures and return statements](http://www.homeandlearn.co.uk/java/java_methods.html)
    * [String operations](https://www.tutorialspoint.com/java/java_strings.htm)

### **Classes to be completed:**
* `MathUtilities`
* `PredicateUtilities`
* `StringUtilities`

### **Instructions:**

1. Fork this Repository
    * [fork](https://help.github.com/articles/fork-a-repo/) this repository to your personal github account
    * [clone](https://help.github.com/articles/cloning-a-repository/) **your** `forked` repository to your local machine.
    * Complete steps 2 and 3  
    * `git add` your changes to the list of your `commited` files.
    * `git commit` your added files to the list of your `staged` files.
    * `git push` your staged files to your remote repository.
    * submit a `pull request` which compares Zipcoder `master` to your `master`.
2. Begin by first ensuring the `main` method in your `ZipcodeRocks` class prints `"Zipcode Rocks!"` upon execution.  
3. Complete each of the method stubs in each of the `main` classes provided.
    * `main` classes are located in `src.main.java.com.zipcodewilmington.danny_do_better_exercises`
    * There are comments above each method stub to describe the expected behavior.
4. Upon completion, open and run the `TestSuite` class to ensure that all tests have 100% success.
    * `TestSuite` is located in `src.test.java.com.zipcodewilmington.danny_do_better_exercises`

## Predicate Utilities
* A _predicate_ is a clause which states something about a subject. (_e.g., **is assigning**_ in _"Leon **is assigning** homework"_)
* Ensure each of the test cases passes successfully in the class [PredicateUtilitiesTest](./PredicateUtilitiesTest.java) by completing each of the method stubs in the class [PredicateUtilities](./PredicateUtilities.java).
* Method Stubs to be completed
	* `boolean isGreaterThan(int x, int y)`
	* `boolean isLessThan(int x, int y)`
	* `boolean isGreaterThanOrEqualTo(int x, int y)`
	* `boolean isLessThanOrEqualTo(int x, int y)`


## Math Utilities
* Ensure each of the test cases passes successfully in the class [MathUtilitiesTest](./MathUtilitiesTest.java) by completing each of the method stubs in the class [MathUtilities](./MathUtilities.java).
* Method Stubs to be completed
	* `Integer add(int, int)`
	* `Long add(long, long)`
	* `Short add(short, short)`
	* `Byte add(byte, byte)`
	* `Float add(float, float)`
	* `Double add(double, double)`
	* `Integer subtract(int, int)`
	* `Long subtract(long, long)`
	* `Short subtract(short, short)`
	* `Byte subtract(byte, byte)`
	* `Float subtract(float, float)`
	* `Double subtract(double, double)`
	* `Integer divide(int, int)`
	* `Long divide(long, long)`
	* `Short divide(short, short)`
	* `Byte divide(byte, byte)`
	* `Float divide(float, float)`
	* `Double divide(double, double)`
	* `Integer multiply(int, int)`
	* `Long multiply(long, long)`
	* `Short multiply(short, short)`
	* `Byte multiply(byte, byte)`
	* `Float multiply(float, float)`
	* `Double multiply(double, double)`
	* `Boolean returnTrue`
	* `Boolean returnFalse`


## String Utilities
* Ensure each of the test cases passes successfully in the class [StringUtilitiesTest](./StringUtilitiesTest.java) by completing each of the method stubs in the class [StringUtilities](./StringUtilities.java).
* Method Stubs to be completed
	* `String concatenation(String, String)`
	* `String concatenation(int, String)`
	* `String getPrefix(String)`
	* `String getSuffix(String)`
	* `Boolean compareTwoStrings(String)`
	* `Character getMiddleCharacter(String)`
	* `String getFirstWord(String)`
	* `String getSecondWord(String)`
	* `String reverse(String)`
